  .text
  .global _hardreset
  .global _cleanregs_custom_weak
  .global main

_hardreset:
  ! %psr[12] - FE = 1 - enable FPU
  ! %psr[7]  - S  = 1 (superuser mode)
  ! %psr[6]  - PS = 1 Bit 6 contains the value of the S bit at the time of the most recent trap
  ! %psr[5]  - ET = 1 This bit determines whether traps are enabled. A trap automatically resets ET to 0.
  set 0x000010e0, %g1
  mov %g1, %psr
  mov %g0, %y

  ! Current window pointer (CWP == %psr[4:0]) is equal to zero.
  ! Each save will decrement it by 1 by modulo (NWIN + 1)
  ! 7, 6, ..., 3 , 2, ... Attempt to set 1-st window active will cause trap window_overflow trap.
  ! 1-st window will be used by trap to save PC and nPC to %l1 and %l2,
  ! and to reserve %o7 and to use other windowed registers.
  or %g0, 0x2, %g1
  mov %g1, %wim

  ! Set trap table base address.
  set _trap_table, %g1
  mov %g1, %tbr

  ! from 'default' folder '_lowlevel_initialization.c' file
  ! _cleanregs_custom_weak:
  !   _lowlevel_set_fp_and_sp.h
  !   _lowlevel_memory_controller_configuration.h
  !   _lowlevel_caches_initialization.h
  !   _lowlevel_watchdog_initialization.h
  !   ...
  call _cleanregs_custom_weak
   nop

  call main
   nop

_exit:
  ta 0